/*
// Created by Tiny on 3/3/2021.
*/
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include "GAME.h"
#include "prof.h"
#include "personnage.h"
#include "map.h"
#include "DS.h"

#define WINDOW_WIDTH (700)
#define WINDOW_HEIGHT (700)

int testposition(Personnage * pers, Prof * prof, DS * exam, MAP * map){

    //test variables
    int testbounds = testboundscol(pers); ;
    int testprof = testprofcol(pers,prof);
    int testmap = testmapcol(pers,map,exam); // = 0 if nothing , 1 if wall, 2 if exam


    //test bounds collision

    if(testbounds) return 4;

	//test prof collision

    if(testprof) return 3;

    //return the map test position

    return testmapcol(pers,map,exam);

}

int testboundscol(Personnage * pers){
    if((pers->x_pers <= 0) || (pers->y_pers <= 0) || (pers->x_pers >= WINDOW_WIDTH - pers->larg_pers) || (pers->y_pers >= WINDOW_HEIGHT - pers->long_pers)) {
        return 1;
    }
    return 0;
}

int testprofcol(Personnage * pers, Prof * prof){

    //calculer milieu
    int x_milieu = pers->x_pers + (pers->larg_pers/2);
    int y_milieu = pers->y_pers + (pers->long_pers/2);

    //test position vs prof
    if (( x_milieu > prof->x_prof) && (x_milieu<prof->x_prof+prof->larg_prof)) {
        if (( y_milieu > prof->y_prof) && (y_milieu < prof->y_prof + prof->long_prof)) {
            return 1;
        }
    }
    return 0;
}

int testmapcol(Personnage * pers,  MAP * map, DS * exam ){
    //calculer milieu
    int x_milieu = pers->x_pers + (pers->larg_pers/2);
    int y_milieu = pers->y_pers + (pers->long_pers/2);

    if (map->functional[y_milieu][x_milieu] == 2){         //if zone exams
        //test exam collision
        if ((x_milieu > exam->x_DS) && (x_milieu < exam->x_DS+exam->larg_DS)) {
                return 2;
        }
    }
    else if (map->functional[y_milieu][x_milieu] == 1){         //if zone wall
        return 1;
    }
    return 0;        //if nothing
}